import 'package:c8y_client/c8y_client.dart';
import 'package:c8y_client/src/core/authentication/cumulocity_credentials.dart';
import 'package:c8y_client/src/core/model/id.dart';

import 'package:c8y_client/src/sdk/client/client.dart';

void main() async {
  var client = Client.withPageSize('https://tenant.service-provider.com',
      CumulocityCredentials('usrname', 'password'), 2000);

  try {
    var mo = await client.inventory().getManagedObject(ID('10407719'));
    print(mo.name);
    print(mo.fragment['Numero_de_Satelites']);
    var currentUser = await client.user().currentUser();
    print(currentUser.userName);

    var mos = await client.inventory().list({'fragmentType': 'c8y_Position'});
    var i = mos.iterator;
    while (i.moveNext()) {
      print(i.current.name);
    }
  } catch (error) {
    print("error : " + error.toString());
  }
}
