class CumulocityLogin {
  String SEPARATOR = '/';

  String tenantId;

  String username;

  CumulocityLogin fromLoginString(String loginString) {
    var usernameIndex = (loginString == null ? -1 : loginString.indexOf(SEPARATOR));

    if (usernameIndex < 0) {
      return CumulocityLogin(null, loginString);
    } else {
      var tenantId = loginString.substring(0, usernameIndex);
      var username = loginString.substring(usernameIndex + 1);
      return CumulocityLogin(tenantId, username);
    }
  }

  CumulocityLogin(String tenantId, String username) {
    this.tenantId = tenantId;
    this.username = username;
  }

  String getTenantId() {
    return tenantId;
  }

  String getUsername() {
    return username;
  }

  String toLoginString() {
    if (tenantId == null) {
      return username;
    } else {
      return tenantId + SEPARATOR + username;
    }
  }
}
