import 'dart:async';

import 'package:c8y_client/src/core/model/base_collection.dart';
import 'package:c8y_client/src/core/model/paged_collection_resource.dart';
import 'package:logger/logger.dart';

class PagedCollectionStreamable<T, C extends BaseCollectionRepresentation<T>> {
  PagedCollectionResource collectionResource;
  C collection;
  var logger = Logger();
  int limit;
  int counter = 1;

  PagedCollectionStreamable(
      this.collectionResource, this.collection, this.limit);

  Future<C> getAllPages() async {
    if (reachedLimit()) {
      return collection;
    } else if (collection.next != null) {
      collection = await collectionResource.getNextPage(collection);
      counter++;
      return await getAllPages();
    } else {
      return collection;
    }
  }

  bool reachedLimit() {
    return limit > 0 && counter >= limit;
  }
}

//

//
//  Paged
//
