import 'dart:async';
import 'dart:collection';
import 'dart:core';

import 'package:c8y_client/src/core/model/base_collection.dart';
import 'package:c8y_client/src/core/model/paged_collection_resource.dart';


class PagedCollectionIterable<T, C extends BaseCollectionRepresentation<T>>
    with IterableMixin<T>, Iterator<T> {
  PagedCollectionResource collectionResource;
  C collection;
  int limit;
  @override
  Iterator<T> iterator;
  int counter;

  PagedCollectionIterable(
      PagedCollectionResource collectionResource, C collection) {
    PagedCollectionIterable.full(collectionResource, collection, 0);
  }

  PagedCollectionIterable.full(
      this.collectionResource, this.collection, this.limit) {
    iterator = collection.iterator;
  }

//  @override
//  Iterator<T> get iterator => return iterator;

  bool reachedLimit() {
    return limit > 0 && counter >= limit;
  }

  @override
  T get current => iterator.current;

  @override
  bool moveNext() {
    print('move next!');

    if (reachedLimit()) {
      return false;
    } else if (iterator.moveNext()) {
      return true;
    } else if (collection.next == null) {
      return false;
    } else {
//      collection = collectionResource.getNextPage(collection);
      iterator = collection.iterator;
      return iterator.moveNext();
    }
  }
}
