import 'package:c8y_client/src/core/model/base_collection.dart';

abstract class PagedCollectionResource<T, C extends BaseCollectionRepresentation<T> > {
  String PAGE_SIZE_KEY = "pageSize";
  String PAGE_NUMBER_KEY = "currentPage";

  Future<C> get(Map<String, Object> queryParams);

  Future<C> getPage(BaseCollectionRepresentation collectionResource, int pageNumber);

  Future<C> getNextPage(BaseCollectionRepresentation collectionResource);

  Future<C> getPreviousPage(BaseCollectionRepresentation collectionResource);
}
