

import 'package:c8y_client/src/core/implementations/PagedCollectionStreamable.dart';
import 'package:c8y_client/src/core/model/paged_collection_representation.dart';
import 'package:c8y_client/src/core/model/paged_collection_resource.dart';
import 'package:c8y_client/src/inventory/model/Managed_object_collection_representation.dart';
import 'package:c8y_client/src/rest/representation/inventory/managed_object_representation.dart';

class PagedManagedObjectCollectionRepresentation
    extends ManagedObjectCollectionRepresentation
    implements
        PagedCollectionRepresentation<ManagedObjectRepresentation,
            ManagedObjectCollectionRepresentation> {
  PagedCollectionResource<ManagedObjectRepresentation,
      ManagedObjectCollectionRepresentation> collectionResource;
  ManagedObjectCollectionRepresentation collection;

  PagedManagedObjectCollectionRepresentation(
      this.collection, this.collectionResource) {
    managedObjects = collection.managedObjects;
    pageStatistics = collection.pageStatistics;
    self = collection.self;
    next = collection.next;
  }


  @override
  Future<ManagedObjectCollectionRepresentation> allPages() async {
    return PagedCollectionStreamable(collectionResource, collection,
            collection.pageStatistics.totalPages)
        .getAllPages();
  }

  Future<ManagedObjectCollectionRepresentation> listWithLimit(int limit) async {
    print('calling allPages');
    return PagedCollectionStreamable(collectionResource, collection, limit)
        .getAllPages();
  }


}
