import 'dart:core';
import 'package:c8y_client/src/core/model/base_collection.dart';
import 'package:c8y_client/src/rest/representation/inventory/managed_object_representation.dart';
import 'package:c8y_client/src/rest/representation/paged_statistics.dart';

class ManagedObjectCollectionRepresentation
    extends BaseCollectionRepresentation<ManagedObjectRepresentation> {
  List<ManagedObjectRepresentation> managedObjects;

  @override
  // TODO: implement pageStatistics
  PageStatistics pageStatistics;
  @override
  String self;
  @override
  String next;

  @override
  Iterator<ManagedObjectRepresentation> get iterator => managedObjects.iterator;

  ManagedObjectCollectionRepresentation();

  ManagedObjectCollectionRepresentation._full(
      this.pageStatistics, this.self, this.next, this.managedObjects);

  static ManagedObjectCollectionRepresentation fromJson(
      Map<String, dynamic> json) {
    var statistics = json['statistics'] as Map<String, Object>;
    var next = json['next'] as String;
    var self = json['self'] as String;
    var managedObjects = json['managedObjects'] as List;
    managedObjects = managedObjects
        .map((mo) => ManagedObjectRepresentation.fromJson(mo))
        .toList();
    return ManagedObjectCollectionRepresentation._full(
        PageStatistics.fromJson(statistics), self, next, managedObjects);
  }

}
