import 'package:http_parser/http_parser.dart';

class CumulocityMediaType extends MediaType {
  static final String VND_COM_NSN_CUMULOCITY = "vnd.com.nsn.cumulocity.";

  static final APPLICATION_VND_COM_NSN_CUMULOCITY =
      "application/" + VND_COM_NSN_CUMULOCITY;

  static final String APPLICATION_JSON_STREAM_TYPE = "application/json-stream";

  static final String APPLICATION_JSON_STREAM =
      new MediaType("application", "json-stream").toString();

  static final CumulocityMediaType ERROR_MESSAGE = MediaType.parse('error');

  static final String VND_COM_NSN_CUMULOCITY_CHARSET = "charset=UTF-8";

  static final String VND_COM_NSN_CUMULOCITY_VERSION = "ver=0.9";

  static final String VND_COM_NSN_CUMULOCITY_PARAMS =
      VND_COM_NSN_CUMULOCITY_CHARSET + ";" + VND_COM_NSN_CUMULOCITY_VERSION;

  static final String ERROR_MESSAGE_TYPE = APPLICATION_VND_COM_NSN_CUMULOCITY +
      "error+json;" +
      VND_COM_NSN_CUMULOCITY_PARAMS;

  CumulocityMediaType(String type, String subtype) : super(type, subtype);

  CumulocityMediaType.fromEntity(String entity)
      : super(
            "application",
            VND_COM_NSN_CUMULOCITY +
                entity +
                "+json;" +
                VND_COM_NSN_CUMULOCITY_PARAMS);
}
