import 'package:c8y_client/src/core/model/id.dart';
import 'package:c8y_client/src/inventory/implementations/managed_object_reference_collection_representation.dart';

class ManagedObjectRepresentation {
  ID id;

  String type;

  String name;

  DateTime lastUpdated;

  DateTime creationTime;

  String owner;

  Map<String, Object> fragment;

  ManagedObjectReferenceCollectionRepresentation childDevices;

  ManagedObjectReferenceCollectionRepresentation childAssets;

  ManagedObjectReferenceCollectionRepresentation childAdditions;

  ManagedObjectReferenceCollectionRepresentation deviceParents;

  ManagedObjectReferenceCollectionRepresentation assetParents;

  ManagedObjectReferenceCollectionRepresentation additionParents;

  ManagedObjectRepresentation();

  static ManagedObjectRepresentation fromJson(Map<String, dynamic> json) {
    var owner = json['owner'] as String;
    json.remove('owner');
    var name = json['name'] as String;
    json.remove('name');
    var fragment = json;
    return ManagedObjectRepresentation()
      ..name = name
      ..owner = owner
      ..fragment = fragment;
  }

  ManagedObjectRepresentation.full(
      ID id,
      this.type,
      this.name,
      this.lastUpdated,
      this.owner,
      this.childAssets,
      this.childDevices,
      this.childAdditions,
      this.assetParents,
      this.deviceParents,
      this.additionParents);

//  factory ManagedObjectRepresentation.fromJson(Map<String, dynamic> json) {
//    var self = json['self'] as String;
//    json.remove('self');
//    var owner = json['owner'] as String;
//    json.remove('owner');
//
//    return ManagedObjectRepresentation()..owner = owner;
//  }
}
