

import 'package:c8y_client/c8y_client.dart';
import 'package:c8y_client/src/inventory/implementations/inventory.dart';
import 'package:c8y_client/src/inventory/model/inventory_api.dart';
import 'package:c8y_client/src/user/implementation/user.dart';
import 'package:c8y_client/src/user/model/user_api.dart';

import 'plataform_parameters.dart';
import 'platform.dart';
import 'rest_operations.dart';

class Client extends PlatformParameters implements Platform {
  final String _host;
  CumulocityCredentials _credentials;
  int _pageSize;

  Client.withPageSize(this._host, this._credentials, this._pageSize)
      : super.withPageSize(_host, _credentials, _pageSize);

  Client(this._host, this._credentials) : super(_host, _credentials);

  @override
  InventoryApi inventory() {
    var restConnector = createRestConnector();
    return Inventory(restConnector, _pageSize, _host);
  }

  @override
  RestOperations rest() {
    // TODO: implement rest
    return null;
  }

  @override
  UserApi user() {
    var restConnector = createRestConnector();
    return User(restConnector, _host);
  }
}
