import 'dart:convert';

import 'package:c8y_client/src/core/authentication/cumulocity_credentials.dart';
import 'package:http/http.dart' as http;

class HTTPClient extends http.BaseClient {
  final http.Client _inner;
  final String SEPARATOR = ':';
  final CumulocityCredentials _credentials;
  final authenticationPrefix = "Basic ";

  HTTPClient(this._inner, this._credentials);

  @override
  Future<http.StreamedResponse> send(http.BaseRequest request) {
    print(request.url);
    request.headers['authorization'] = getAuthenticationHeader();
    return _inner.send(request);
  }

  String getAuthenticationHeader() {
    return authenticationPrefix +
        base64Encode(utf8.encode(_credentials.getLogin().toLoginString() +
            SEPARATOR +
            _credentials.getPassword()));
  }
}
