import 'package:c8y_client/src/core/authentication/cumulocity_credentials.dart';
import 'package:c8y_client/src/sdk/client/rest_connector.dart';

class PlatformParameters {
  final String _host;
  int _pageSize = 5;
  RestConnector _restConnector;
  int _port = 443;
  String _userName;
  String _password;
  String _tenant;
  final CumulocityCredentials _credentials;

  PlatformParameters.withPageSize(this._host, this._credentials, this._pageSize) {
    extractDataFromCredentials(_credentials);
  }
  PlatformParameters(this._host, this._credentials) {
    extractDataFromCredentials(_credentials);
  }

  void extractDataFromCredentials(CumulocityCredentials credentials) {
    _tenant = credentials.getTenantId();
    _userName = credentials.getUsername();
    _password = credentials.getPassword();
  }

  CumulocityCredentials get credentials => _credentials;

  String get host => _host;

  String get password => _password;

  set port(int port) => _port = port;

  int get port => _port;

  int get pageSize => _pageSize;

  RestConnector createRestConnector() {
    _restConnector ??= RestConnector(this);
    return _restConnector;
  }
}
